rem @echo off
Rem
Rem - delete empty calendars
Rem - delete expired calendars
Rem

set user=sa
set pass=xxxx
set sqlserver=bgbulab51
rem - if you loaded the sql procedures you can set use_proc=y, else use use_proc=n (and we will use the included sql queries)
set use_proc=n

echo Start deleting expired and empty calendars calendars

Rem --- option 1 - delete expired calendars via detail sql statements
if %use_proc%==y goto uproc
sqlcmd -U %user% -P %pass% -S %sqlserver% -d CA_UIM -Q "DECLARE @message2 varchar(100);DECLARE @cs2 AS NVARCHAR(500);DECLARE plancursor CURSOR for select distinct ms.schedule_id from CM_COMPUTER_SYSTEM cs INNER JOIN MAINTENANCE_SCHEDULE_MEMBERS msm  ON cs.cs_id=msm.CS_ID INNER JOIN MAINTENANCE_WINDOW mw  ON msm.SCHEDULE_ID=mw.SCHEDULE_ID INNER JOIN MAINTENANCE_SCHEDULE ms ON msm.SCHEDULE_ID=ms.SCHEDULE_ID WHERE mw.END_TIME <GETDATE() and ms.RECURRENCE_PATTERN = 0 and ms.RECURRENCE_PERIOD = 0 group by name,ip,origin,ms.schedule_id,ms.SCHEDULE_NAME,ms.DESCRIPTION;open plancursor fetch next from plancursor into @cs2 while @@FETCH_STATUS = 0 BEGIN print ' ' select @message2 = '-- Deleting member(s) from schedule_id: ' + @cs2 + ' from MAINTENANCE_SCHEDULE_MEMBERS';print @message2 delete from MAINTENANCE_SCHEDULE_MEMBERS where SCHEDULE_ID = @cs2; select @message2 = 'DELETING MAINTENANCE WINDOWS connected to schedule_id: ' + @cs2 + ' from MAINTENANCE_WINDOW' print @message2 delete from MAINTENANCE_WINDOW where SCHEDULE_ID = @cs2 select @message2 = '-- DELETING SCHEDULE ID: ' + @cs2 + ' from MAINTENANCE_SCHEDULE' print @message2 delete from MAINTENANCE_SCHEDULE where SCHEDULE_ID = @cs2; FETCH NEXT FROM plancursor into @cs2 END CLOSE plancursor;DEALLOCATE plancursor;"

Rem --- delete empty calendars
sqlcmd -U %user% -P %pass% -S %sqlserver% -d CA_UIM -Q "DECLARE @message varchar(100);DECLARE @cs AS NVARCHAR(500);DECLARE devicecursor CURSOR for SELECT ms.SCHEDULE_ID from MAINTENANCE_SCHEDULE ms left join MAINTENANCE_SCHEDULE_MEMBERS msm on msm.SCHEDULE_ID = ms.SCHEDULE_ID where msm.CS_ID IS NULL; open devicecursor fetch next from devicecursor into @cs while @@FETCH_STATUS = 0 BEGIN print ' ' select @message = '-- DELETING SCHEDULE ID: ' + @cs + ' from MAINTENANCE_SCHEDULE' print @message delete from MAINTENANCE_SCHEDULE where MAINTENANCE_SCHEDULE.SCHEDULE_ID = @cs; select @message = 'DELETING MAINTENANCE WINDOWS connected to schedule_id: ' + @cs + ' from MAINTENANCE_WINDOW' delete from MAINTENANCE_WINDOW where MAINTENANCE_WINDOW.SCHEDULE_ID = @cs; print @message FETCH NEXT FROM devicecursor into @cs END CLOSE devicecursor; DEALLOCATE devicecursor;" 

goto :endmaint

:uproc
Rem --- option 2 - define these sql statements as procedures and call the procedure
Rem - 1 - delete expired calendars
sqlcmd -U %user% -P %pass% -S %sqlserver% -d CA_UIM -Q "exec SP_Maint_Delete_Expired;"

Rem - 2 - delete empty calendars
sqlcmd -U %user% -P %pass% -S %sqlserver% -d CA_UIM -Q "exec SP_Maint_Delete_Empty;"

:endmaint
echo End deleting the expired and empty UIM maintenance calendars

